// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.bulkeditor.command;

import org.apache.log4j.Logger;
import org.eclipse.core.expressions.PropertyTester;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IEditorInput;

import eu.etaxonomy.cdm.model.common.Group;
import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
import eu.etaxonomy.taxeditor.bulkeditor.BulkEditor;
import eu.etaxonomy.taxeditor.bulkeditor.input.AbstractBulkEditorInput;
import eu.etaxonomy.taxeditor.bulkeditor.input.GroupEditorInput;
import eu.etaxonomy.taxeditor.bulkeditor.input.OccurrenceEditorInput;
import eu.etaxonomy.taxeditor.ui.section.description.DerivedUnitElement;

/**
 * <p>BulkEditorPropertyTester class.</p>
 *
 * @author p.ciardelli
 * @created 21.09.2009
 * @version 1.0
 */
public class BulkEditorPropertyTester extends PropertyTester {
	private static final Logger logger = Logger
			.getLogger(BulkEditorPropertyTester.class);

	private static final String GROUP = "isGroup";
	private static final String DERIVEDUNIT = "isDerivedUnit";
	/* (non-Javadoc)
	 * @see org.eclipse.core.expressions.IPropertyTester#test(java.lang.Object, java.lang.String, java.lang.Object[], java.lang.Object)
	 */
	/** {@inheritDoc} */
	public boolean test(Object receiver, String property, Object[] args,
			Object expectedValue) {
		BulkEditor bulkEditor = (BulkEditor) receiver;
			
		if ("isMergingEnabled".equals(property)) {			
			IEditorInput input = bulkEditor.getEditorInput();
			if (input instanceof AbstractBulkEditorInput) {
				return ((AbstractBulkEditorInput) input).isMergingEnabled();
			}			
		}
		if(GROUP.equals(property)){
			return isGroup(bulkEditor);
		}
		
		if (DERIVEDUNIT.equals(property)){
			
			return isDerivedUnit(bulkEditor);
		}
//		if (("isPublishFlagEditingEnabled").equals(property)) {
//			IEditorInput input = bulkEditor.getEditorInput();
//			if (input instanceof NameEditorInput) {
//				return ((NameEditorInput) input).isPublishFlagEnabled();
//			}
//		}
		return false;
	}
	
	private boolean isDerivedUnit(BulkEditor bulkEditor) {
		IEditorInput input = bulkEditor.getEditorInput();
		return (input instanceof OccurrenceEditorInput) ? true : false;
	}

	private boolean isGroup(BulkEditor bulkEditor) {
		IEditorInput input = bulkEditor.getEditorInput();
		return (input instanceof GroupEditorInput) ? true : false;
	}
}
